/*
 * shop  Brian Rice  rice@dg-rtp.dg.com  1989-91
 *
 * This is shop.c, the main routine.
 *
 * $Date: 91/07/01 18:45:31 $
 */

static char rcsid[] = "$What: <@(#) shop.c,v	2.1> $";

#include <stdio.h> 
#include <string.h>
#include <ctype.h>

#if PWD_SUPPORTED
#include <pwd.h>
#endif

#include "shop.h"

char *cmdname;

main(argc,argv)
int argc;
char *argv[];
{
	char *getitem();
	char *cap_words();
#if PWD_SUPPORTED
        struct passwd *getpwuid(), *my_passwd;
#if VERBOSE_GECOS
	char *ax_at_char();
#endif
#endif
	char my_text[MY_TEXT_LENGTH];
	BOOLEAN middname = FALSE;
	BOOLEAN header = TRUE;
	BOOLEAN numbers = TRUE;
	int inx;
	int itemcount = DEFAULT_ITEMCOUNT;
	char *s;

	cmdname = argv[0];

	while (--argc > 0) {
		switch ((*++argv)[0]) {
			case '-':
				for (s = argv[0]+1; *s; s++)
					switch (*s) {
						case 'h': header = FALSE;
					  	  	  break;
						case 'n': numbers = FALSE;
						  	  break;
						case 'm': middname = TRUE;
						  	  break;
						default:
							  (void) 
						          fprintf(stderr,
						              SHOP_USAGE,
						              cmdname);
							  exit(1);
					}
				break;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9': itemcount = atoi(argv[0]);
				  break;
		}
	}
	
	if (middname) {
#if PWD_SUPPORTED
		my_passwd = getpwuid(getuid());
#endif

		(void) printf("%s, your middle name is \"%s.\"\n",
#if PWD_SUPPORTED
#if VERBOSE_GECOS
		  	ax_at_char(my_passwd->pw_gecos),
#else
		  	my_passwd->pw_gecos,
#endif
#else
			DEFAULT_NAME,
#endif
		  	cap_words(getitem(my_text)));
	} else {
		if (header) {
			(void) printf(HEADER_MSG);
		}

		for (inx=0; inx < itemcount; inx++) {
			(void) getitem(my_text);
			my_text[0] = toupper(my_text[0]);
			if (numbers) {
				(void) printf("(%d) %s",inx+1,my_text);
			} else {
				(void) fputs(my_text,stdout);
			}
			(void) putc('\n',stdout);
		}
	}
	exit(0);
	/*NOTREACHED*/
}

